window.unasEncrypt = null;
var urlSearchParams = new URLSearchParams(window.location.search);

var params = Object.fromEntries(urlSearchParams.entries());

function encryptAndEncodeStr(str) {
  if (window.unasEncrypt) {
    str = window.unasEncrypt.encrypt(str);
    str = encodeURI(str).replace(/\+/g, '%2B');
  } else {
    alert('window.unasEncrypt is null');
  }
  return str;
}

//获取公钥
function getPublicKey(cb) {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "unas_publickey"
    }),
    success: function(result) {
      var encrypt = new JSEncrypt();
      encrypt.setPublicKey(result.results.publickey);
      window.unasEncrypt = encrypt;
      if (typeof(cb) === 'function') {
        cb();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function login() {

  getPublicKey(function() {
    doUnasLogin();
  });
}


function doUnasLogin() {

  var userName = jQuery.trim(jQuery("#userName").val());
  var userPassword = jQuery.trim(jQuery("#unas_pwd").val());
  userPassword = encryptAndEncodeStr(JSON.stringify(userPassword).substring(1, JSON.stringify(userPassword).length - 1));
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "sso_login",
      params: {
        code: params.code,
        uid: userName,
        pwd: userPassword
      }
    }),
    success: function(data) {

      if (data.err == 0) {
        sendMessage(data);
      } else {
        $('#jv-errormsg').show();
      }
    }
  });
};

function sendMessage(data) {

  var dataJson = JSON.stringify({
    data: data
  });
  if (window.opener) {
    window.opener.postMessage(dataJson, '*');
  }

}

UNAS.LoadTranslation('/apps/ssoserver/ssologin/languages/LoginTranslation?v=6.0.1', function() {

  if (UNAS.SupportedLanguages.indexOf(params.language) > -1) {
    UNAS.CurrentLanguage = params.language || UNAS.CurrentLanguage;
  }else {
    UNAS.CurrentLanguage = 'English';
  }

  var rt = document.getElementById('jv-container-normal');
  var pageTranslators = window.top.UNAS.CreateNodesTranslators(rt);
  var OnChangeLanguage = function(e) {
    for (var i = 0; i < pageTranslators.length; i++) {
      var node = pageTranslators[i].node;
      var p = pageTranslators[i].translateProperty;
      node[p] = window.top.UNAS._(pageTranslators[i].originalText);
    }
  };
  OnChangeLanguage();
  window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
  window.addEventListener("unload", function(e) {
    window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage);
  }, false);

  jQuery('#jv-langlist p').html(UNAS.CurrentLanguage);

  jQuery('#jv-select-lang').html('');
  var login_select_content = document.getElementById('jv-select-lang');

  for (var i = 0; i < UNAS.SupportedLanguages.length; i++) {
    var mi_a = document.createElement("a");

    // 下拉选择
    mi_a.onclick = function(e) {
      e.stopPropagation();
      var txt = jQuery(this).children("span").text();
      jQuery('#jv-langlist p').html(txt);

      UNAS.CurrentLanguage = txt;
      UNAS.Event.fireEvent('ChangeLanguage');
      jQuery(this).parent().hide();
    };

    var menuA_a = document.createElement('span');
    var menuTextNode_a = document.createTextNode(UNAS.SupportedLanguages[i]);
    menuA_a.appendChild(menuTextNode_a);
    mi_a.appendChild(menuA_a);
    login_select_content.appendChild(mi_a);
  };

}, false);

(function() {

  jQuery('#jv-langlist').click(function(e) {
    e.stopPropagation();
    jQuery('#jv-select-lang').slideToggle();
  });

  jQuery(document).click(function(e) {
    e.stopPropagation();
    jQuery('#jv-select-lang').hide();
  });

})()
